import math

g = 9.81
EPS = 1e-8

# find the intersections of two quadratics
# for this problem only, don't use as a general-purpose quadratic solver!
def solve(a, b, c, d, e, f):
    a, b, c = a-d, b-e, c-f

    if abs(a) < EPS: return None, None

    disc = b**2 - 4*a*c

    if disc < EPS: return None, None

    disc = math.sqrt(disc)

    x1, x2 = (-b-disc)/(2*a), (-b+disc)/(2*a)
    if x2 < x1: x1, x2 = x2, x1

    return x1, x2


def normalize(x, y):
    norm = math.sqrt(x*x + y*y)
    return (x/norm, y/norm)

for _ in range(int(input())):
    j, p, h, l = map(float, input().split())

    # kinetic energy gain is (height drop) * mass * g
    # height drop is j here
    # mass cancels out later, so we just ignore it now
    kin = g*j
    v0 = math.sqrt(2*kin)

    # coefficient of the quadratic defining the flight curve
    a, b, c = -0.5*g/(v0**2), 0, h+p

    # coefficients of the quadratic defining the first part of the slope
    a1, b1, c1 = -2*h/(l**2), 0, h

    # coefficients of the quadratic defining the second part of the slope
    a2, b2, c2 = 2*h/(l**2), -4*h/l, 2*h

    x1, x2 = solve(a, b, c, a1, b1, c1)
    if x1 is not None and 0 <= x2 and x2 <= l/2:
        x = x2
        hill_tangent = normalize(1, 2*a1*x + b1)
    else:
        x1, x2 = solve(a, b, c, a2, b2, c2)
        if x2 is not None and l/2 <= x2 and x2 <= l:
            x = x2
            hill_tangent = normalize(1, 2*a2*x + b2)
        else:
            _, x = solve(a, b, c, 0.0, 0, 0.0)
            hill_tangent = normalize(1, 0)
    ski_tangent = normalize(1, 2*a*x + b)

    # now x is the landing point

    # total height drop from the start of the run
    drop = h+p+j - (a*x*x + b*x + c)

    # landing speed
    speed = math.sqrt(2*g*drop)

    angle = 180/math.pi*math.acos(ski_tangent[0]*hill_tangent[0] + ski_tangent[1]*hill_tangent[1])

    print(x, speed, angle)
