#include <iostream>
#include <cstring>

#define MAXN 300010
#define LOGN 19
#define NIL -2

using namespace std;

int p[MAXN][LOGN];
int d[MAXN];

int depth(int v) {
    if (d[v] == -1) d[v] = depth(p[v][0])+1;
    return d[v];
}

// should have p[v][0] already stored
int pval(int v, int i) {
    if (p[v][i] == -1) {
        int u = pval(v, i-1);
        p[v][i] = (u==NIL?NIL:pval(u, i-1));
    }
    return p[v][i];
}

// which tree node represents stack i?
int tree[MAXN];

int lca(int u, int v) {
    if (depth(u) < depth(v)) return lca(v, u);

    for (int i = LOGN-1; i >= 0; --i)
        if (pval(u, i) != NIL && depth(pval(u, i)) >= depth(v))
            u = pval(u, i);

    if (u == v) return u;

    for (int i = LOGN-1; i >= 0; --i)
        if (pval(u, i) != NIL && pval(u, i) != pval(v, i)) {
            u = pval(u, i);
            v = pval(v, i);
        }

    return p[u][0];
}

int main() {
    int n;
    cin >> n;

    memset(p, -1, sizeof(p));
    memset(d, -1, sizeof(d));

    d[0] = 0;
    p[0][0] = NIL;
    tree[0] = 0;

    for (int i = 1; i <= n; ++i) {
        char c;
        int u, v;
        cin >> c >> u;

        if (c == 'a') {
            tree[i] = i;
            p[i][0] = tree[u];
        }
        else if (c == 'b') {
            tree[i] = p[tree[u]][0];
            cout << tree[u] << endl;
        }
        else {
            cin >> v;

            // cout << " * " << u << ' ' << v << endl;

            u = tree[u];
            v = tree[v];

            // for (int uu = u; uu != -2; uu = p[uu][0]) cout << uu << ' '; cout << endl;
            // for (int uu = v; uu != -2; uu = p[uu][0]) cout << uu << ' '; cout << endl;
            //
            // cout << u << ' ' << v << ' ' << lca(u, v) << endl;

            tree[i] = u;

            cout << depth(lca(u, v)) << endl;
        }
    }

    return 0;
}
