#include <iostream>
#include <algorithm>
#include <vector>

#define MAXN 200010
#define LOGN 18

using namespace std;

typedef long long ll;

vector<int> g[MAXN];
int up[LOGN][MAXN], depth[MAXN];

void dfs(int v, int pre, int d) {
    depth[v] = d;

    for (auto w : g[v])
        if (w != pre)
            dfs(w, v, d+1);

    up[0][v] = pre;
}

int lca(int a, int b) {
    // bool out = (a == 1 && b == 9);
    if (depth[a] > depth[b]) swap(a, b);

    for (int j = LOGN-1; j >= 0; --j)
        if (depth[a] + (1<<j) <= depth[b]) {
            // if (out) cout << b << " --> " << up[j][b] << endl;
            b = up[j][b];
        }

    if (a == b) return a;

    for (int j = LOGN-1; j >= 0; --j)
        if (up[j][a] != up[j][b]) {
            a = up[j][a];
            b = up[j][b];
        }
    return up[0][a];
}

ll dist(ll a, ll b) {
    return depth[a] + depth[b] - 2*depth[lca(a, b)] + 1;
}

int main() {
    int n;
    cin >> n;
    for (int i = 0; i < n-1; ++i) {
        int u, v;
        cin >> u >> v;
        g[--u].push_back(--v);
        g[v].push_back(u);
    }

    for (auto x : up) fill(x, x+n, -1);
    dfs(0, -1, 0);

    // for (int i = 0; i < n; ++i) cout << depth[i] << ' '; cout << endl;

    for (int j = 1; j < LOGN; ++j)
        for (int v = 0; v < n; ++v)
            if (up[j-1][v] != -1)
                up[j][v] = up[j-1][up[j-1][v]];

    ll tot = 0;
    for (int a = 1; a <= n; ++a)
        for (int b = 2*a; b <= n; b += a) {
            //cout << a << ' ' << b << ' ' << dist(a-1, b-1) << endl;
            tot += dist(a-1, b-1);
        }

    cout << tot << endl;

    return 0;
}
